import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class menus extends Applet{

    static String filename;    
    static String displayStrings[] = new String[100];
    static int numberDisplayLines = 0;

    public static void main(String args[])
    {
        menus applet = new menus();

        menusFrame frame = new menusFrame("The menus application", applet);

        frame.show();
        frame.hide();
        frame.resize(320, 240);

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
    }

    public boolean action (Event e, Object o)
    {
        String caption = (String)o;
        numberDisplayLines = 0;
        URL url = null;
        String filename = "";

        try {
            if(caption.equals("Document 1")) { 
                filename = "file:////c://xml//menus//menus1.xml";
            }
            if(caption.equals("Document 2")) { 
                filename = "file:////c://xml//menus//menus2.xml";
            }
            if(caption.equals("Document 3")) { 
                filename = "file:////c://xml//menus//menus3.xml";
            }
            url = new URL(filename);
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            doTree(d.getRoot(), "");
            repaint();
        }
        return true;
    }


    void doTree(Element elem, String indent)
    {
        String ind = "";

        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();
            if(elem2.getType() != com.ms.xml.Element.ELEMENT){

                int textLength = elem2.getText().length();
                    displayStrings[numberDisplayLines++] = indent + elem2.getText().substring(0, textLength);
            }
            else{
                if(elem2.getTagName().equals("INDENTDOUBLE")){
                    ind = indent + "    ";
                }
                if(elem2.getTagName().equals("INDENT")){
                    ind = indent + "  ";
                }
                doTree(elem2, ind);
            }
        }
    }

    public void paint(Graphics g)
    {
        int y = 0;
        FontMetrics fontmetrics = getFontMetrics(getFont());

        for(int index = 0; index < numberDisplayLines; index++){
            y += fontmetrics.getHeight();
            g.drawString(displayStrings[index], 0, y);
        }
    }
}    

class menusFrame extends Frame
{
    Menu Menu1;
    MenuBar Menubar1;
    menus applet;

    public menusFrame(String str, menus a)
    {
        super(str);
        applet = a;
        Menubar1 = new MenuBar();
        Menu1 = new Menu("File");
        Menu1.add(new MenuItem("Document 1"));
        Menu1.add(new MenuItem("Document 2"));
        Menu1.add(new MenuItem("Document 3"));
        Menubar1.add(Menu1);
        setMenuBar(Menubar1); 
    }

    public boolean action (Event e, Object o){
        if(e.target instanceof MenuItem){
            applet.action(e, o);
        }
        return true;
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

